
#import <OBJBRuntime/OBJBRuntime.h>

#import "Global.h"


Global *OBJB_sharedGlobalSingleton = nil;


@implementation Global

- (id) init
{
  if ((self = [super init])){
    [self Init];
  }
  return self;
}

- (void) finalize
{
  [super finalize];
}

- (void) awakeFromNib
{
  if (OBJB_sharedGlobalSingleton == nil) OBJB_sharedGlobalSingleton = self; //[self Init];
}

- (void) Init
{
}

+ (Global *) sharedGlobal
{
  @synchronized(self){
    if (OBJB_sharedGlobalSingleton == nil) OBJB_sharedGlobalSingleton = [[Global alloc] init];
    return OBJB_sharedGlobalSingleton;
  }
}


@end


id OBJB_GLOBAL_INIT(id object, const char *Name_OnAction)

{
    id aGlobal = [[Global alloc] init];
    if ([object respondsToSelector:sel_registerName(Name_OnAction)]){
        [aGlobal setAction:sel_registerName(Name_OnAction)];
        [aGlobal setTarget:object];
    }
    return aGlobal;
}

id OBJB__GLOBAL(id m)

{

    if (m == nil || [m isKindOfClass:[Global class]]){

        return m;

    }

    OBJB_EXCEPTION(OBCastException, @"'Global' expected", [m description]);

    return nil;

}
@implementation OBJB_Application
- (void)reportException:(NSException *)anException
{
  NSString *s = [[NSString alloc] initWithFormat: @"\n\nException in\n file '%@'\n at '%@'\n line '%@'\n\ncallStackSymbols:\n%@", ObjBF(), ObjBS(), ObjBL(), [[anException callStackSymbols] description]];
  NSLog(@"%@", s);
  OBJB_MSGBOX(OBJB_ADD(@"Exception ", [anException name]), OBJB_ADD(OBJB_ADD([anException reason], [anException userInfo] == nil ? @"" : OBJB_ADD(@"\n\n", [anException userInfo])), s));
}
@end

int main (int argc, char *argv[])
{
  [OBJB_Application sharedApplication];
  return NSApplicationMain(argc,  (const char **) argv);
}

